#!/usr/bin/python
import pylab as pb
pb.ion()
import sys
import numpy as np
import matplotlib.pyplot as plt

pb.close('all')

theta = np.linspace(np.pi/20.0,np.pi/2.5,3)
x = np.cos(theta)
y = np.sin(theta)

plt.figure(1)
ax = plt.axes()
ax.clear()
ax.set_xlim([0,1.5])
ax.set_ylim([0,1.5])
for i in range(0,theta.size):
    ax.arrow(0,0,x[i],y[i],head_width=0.05,head_length=0.1)
pb.savefig('row_space.png',transparent=True, bbox_inches='tight', pad_inches=0)


plt.figure(2)
ax = plt.axes()
ax.clear()
ax.set_xlim([-0.1,1.5])
ax.set_ylim([-0.1,1.5])
ax.scatter(x,y,marker='o',c='b',s=[100])
ax.arrow(0,0,1.2,0,head_width=0.05,head_length=0.1)
ax.arrow(0,0,0,1.2,head_width=0.05,head_length=0.1)
pb.savefig('col_space.png',transparent=True, bbox_inches='tight', pad_inches=0)
