#!/usr/bin/python
import pylab as pb
pb.ion()
import sys
import numpy as np
import matplotlib.pyplot as plt
from scipy.stats import multivariate_normal
import seaborn as sns
from sys import platform as _platform


def conditional_normal(mu,sigma,x1):
    var = sigma[1,1]-sigma[1,0]*(1.0/sigma[0,0])*sigma[0,1]
    mean = sigma[1,0]*(1.0/sigma[0,0])*x1

    pdf = multivariate_normal(mean,var)

    return pdf


pb.close('all')

mu = np.array([0,0]);
K = np.array([[1.0, 0.5],[0.5,1.0]])
K2 = np.array([[1.0, 0.99],[0.99,1.0]])
K3 = np.array([[1.0, 0.0],[0.0,1.0]])
pdf = multivariate_normal(mu,K)
pdf2 = multivariate_normal(mu,K2)
pdf3 = multivariate_normal(mu,K3)

N = 100
x = np.linspace(-4,4,N)
y = np.linspace(-4,4,N)

# plot joint distribution (sorry no seaborn this time)
x1,x2 = np.meshgrid(x,y)
pos = np.vstack((x1.flatten(),x2.flatten()))
pos = pos.T
Z = pdf.pdf(pos)
Z2 = pdf2.pdf(pos)
Z3 = pdf3.pdf(pos)
Z = Z.reshape(N,N)
Z2 = Z2.reshape(N,N)
Z3 = Z3.reshape(N,N)
pb.figure(1)
pb.clf()
plt.contour(x1,x2,Z,4,colors='k')
pb.grid('off')
pb.savefig('K0p5_joint.png');

pb.figure(2)
pb.clf()
plt.contour(x1,x2,Z2,4,colors='k')
pb.grid('off')
pb.savefig('K0p99_joint.png');

pb.figure(3)
pb.clf()
plt.contour(x1,x2,Z3,4,colors='k')
pb.grid('off')
pb.savefig('K0p0_joint.png');


# plot conditional distributions
cpdf1 = conditional_normal(mu,K,1)
cpdf2 = conditional_normal(mu,K,2)
cpdfm3 = conditional_normal(mu,K,-3)

Z1 = cpdf1.pdf(y)
Z2 = cpdf2.pdf(y)
Zm3 = cpdfm3.pdf(y)

pb.figure(1)
plt.plot(Z1+1,y,'r')
pb.savefig('K0p5_cond1.png');
plt.plot(Z2+2,y,'g')
pb.savefig('K0p5_cond2.png');
plt.plot(Zm3-3,y,'b')
pb.savefig('K0p5_cond3.png');

cpdf1 = conditional_normal(mu,K2,1)
cpdf2 = conditional_normal(mu,K2,2)
cpdfm3 = conditional_normal(mu,K2,-3)

Z1 = cpdf1.pdf(y)
Z2 = cpdf2.pdf(y)
Zm3 = cpdfm3.pdf(y)

pb.figure(2)
plt.plot(Z1+1,y,'r')
pb.savefig('K0p99_cond1.png');
plt.plot(Z2+2,y,'g')
pb.savefig('K0p99_cond2.png');
plt.plot(Zm3-3,y,'b')
pb.savefig('K0p99_cond3.png');

cpdf1 = conditional_normal(mu,K3,1)
cpdf2 = conditional_normal(mu,K3,2)
cpdfm3 = conditional_normal(mu,K3,-3)

Z1 = cpdf1.pdf(y)
Z2 = cpdf2.pdf(y)
Zm3 = cpdfm3.pdf(y)

pb.figure(3)
plt.plot(Z1+1,y,'r')
pb.savefig('K0p0_cond1.png');
plt.plot(Z2+2,y,'g')
pb.savefig('K0p0_cond2.png');
plt.plot(Zm3-3,y,'b')
pb.savefig('K0p0_cond3.png');









