#!/usr/bin/python
import pylab as pb
pb.ion()
import sys
import numpy as np
import matplotlib.pyplot as plt

def k_periodic(X,l,p,sigma2):
    K = np.zeros((X.shape[0],X.shape[0]))
    for i in range(0,X.shape[0]):
        for j in range(0,X.shape[0]):
            K[i,j] = sigma2*np.exp(-2.0/(l*l)*np.power(np.sin(np.pi*np.sqrt((X[i,:]-X[j,:]).dot((X[i,:]-X[j,:]).T))/p),2))
    return K
def k_se(X,l,sigma2):
    K = np.zeros((X.shape[0],X.shape[0]))
    for i in range(0,X.shape[0]):
        for j in range(0,X.shape[0]):
            K[i,j] = sigma2*np.exp(-1.0/(2.0*l*l)*(X[i,:]-X[j,:]).dot((X[i,:]-X[j,:]).T))
    return K

X = np.linspace(2,10,100)
X = np.vstack((X,X))
X = X.T
K = k_periodic(X,1,2,3)
pb.figure(1)
pb.imshow(K,interpolation='nearest');
pb.savefig('K_periodic.png',transparent=True, bbox_inches='tight', pad_inches=0)

for i in range(0,K.shape[0]/2):
    for j in range(K.shape[0]/2+1,K.shape[0]):
        K[i,j] = 0
    
for i in range(K.shape[0]/2+1,K.shape[0]):
    for j in range(0,K.shape[0]/2):
        K[i,j] = 0
pb.figure(2)
pb.imshow(K,interpolation='nearest');
pb.savefig('K_block.png',transparent=True, bbox_inches='tight', pad_inches=0)



K = k_se(X,1,2)
pb.figure(3)
pb.imshow(K,interpolation='nearest');
pb.savefig('K_se.png',transparent=True, bbox_inches='tight', pad_inches=0)



sys.exit(0)

pb.close('all')
X = np.linspace(1,2,100)
X = np.vstack((X,X))
X = X.T
l = np.linspace(0.01,1,100)
d = np.zeros(l.size)
for i in range(0,l.size):
    K = k_se(X,l[i],1)
    d[i] = np.log((np.linalg.det(K)))


